<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigAltesitufunc extends Base\MigAltesitufunc
{

    /**
     * @param $nraltesitufunc
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setNraltesitufunc ($nraltesitufunc) {
        $nraltesitufunc = \Importacao\Logic\Validacoes::verificaChaveDuplicada('GPE_ALTESITUFUNC', 'NRALTESITUFUNC', ProjetoImportacao::getNrorg(), $nraltesitufunc);
        $this->nraltesitufunc = $nraltesitufunc;
    }

    /**
     * @param $nrvinculom
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setNrvinculom ($nrvinculom) {
        $nrvinculom = \Importacao\Logic\Validacoes::verificaChaveMae('GPE_VINCULOM', 'NRVINCULOM', ProjetoImportacao::getNrorg(), $nrvinculom);
        $this->nrvinculom = $nrvinculom;
    }

    /**
     * @param $nrsitufuncm
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setNrsitufuncm ($nrsitufuncm) {
        $nrorg = ProjetoImportacao::getNrorgPadrao();
        $situfunc = \Folha\Entities\GpeSitufuncm::findOneByNrsitufuncmAndNrorg($nrsitufuncm, $nrorg);
        
        if (is_object($situfunc)) {
            $this->nrsitufuncm = $nrsitufuncm;
        } else {
            throw new \Exception("O código da Situação Funcional '$nrsitufuncm' não foi encontrado.");
        }
    }

    /**
     * @param $dtprorrsitufunc
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setDtprorrsitufunc ($dtprorrsitufunc) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtprorrsitufunc)) {
            if (!empty($dtprorrsitufunc)) {
                throw new \Exception("Dt. Próxima Situação: Data '$dtprorrsitufunc' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtprorrsitufunc instanceof \DateTime)) {
            $dtprorrsitufunc = DateUtil::getDataDeString($dtprorrsitufunc);
        }

        $this->dtprorrsitufunc = $dtprorrsitufunc;
    }

    /**
     * @param $dtinisitufunc
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setDtinisitufunc ($dtinisitufunc) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinisitufunc)) {
            throw new \Exception("Campo Obrigatório - Dt. Início Situação: Data '$dtinisitufunc' com formato inválido ou em branco.");
        }

        if (!($dtinisitufunc instanceof \DateTime)) {
            $dtinisitufunc = DateUtil::getDataDeString($dtinisitufunc);
        }

        $this->dtinisitufunc = $dtinisitufunc;
    }

    /**
     * @param $dtpreviretositu
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setDtpreviretositu ($dtpreviretositu) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtpreviretositu)) {
            if (!empty($dtpreviretositu)) {
                throw new \Exception("Dt. Retorno Situação: Data '$dtpreviretositu' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtpreviretositu instanceof \DateTime)) {
            $dtpreviretositu = DateUtil::getDataDeString($dtpreviretositu);
        }

        $this->dtpreviretositu = $dtpreviretositu;
    }

    /**
     * @param $dtverifsitufunc
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setDtverifsitufunc ($dtverifsitufunc) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtverifsitufunc)) {
            if (!empty($dtverifsitufunc)) {
                throw new \Exception("Dt. Verifica Situação: Data '$dtverifsitufunc' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtverifsitufunc instanceof \DateTime)) {
            $dtverifsitufunc = DateUtil::getDataDeString($dtverifsitufunc);
        }

        $this->dtverifsitufunc = $dtverifsitufunc;
    }

    /**
     * @param $dtfimsitufunc
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setDtfimsitufunc ($dtfimsitufunc) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtfimsitufunc)) {
            if (!empty($dtfimsitufunc)) {
                throw new \Exception("Dt. Fim Situação: Data '$dtfimsitufunc' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtfimsitufunc instanceof \DateTime)) {
            $dtfimsitufunc = DateUtil::getDataDeString($dtfimsitufunc);
        }

        $this->dtfimsitufunc = $dtfimsitufunc;
    }

    /**
     * @param $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setDtultatu ($dtultatu) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\MigAltesitufunc
     */
    public function setDtinclusao ($dtinclusao) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

}