<?php

namespace Services\Logic\IntegracaoPm;

class IntegracaoPmLogic
{
    const CLIENT_ID = "cd7e82153be60953102055f9b19a50a4";
    const CLIENT_SECRET = "8c673f38ade42e5e3318c830d9522bd2";
    protected static $token;
    protected static $header;
    private static $urlServicoPm;

    protected function getUtlServicoPm() {
        if (empty(self::$urlServicoPm)) {
            $sql = "SELECT DESCENDERECOSERVICOPM FROM FCT_PARAMETROGERAL";
            $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
            if (count($retorno) > 0)
                self::$urlServicoPm = $retorno[0]["DESCENDERECOSERVICOPM"];
            else
                throw new \Exception("Endereço do serviço de integração com o PM não está parametrizado.");
        }
        return self::$urlServicoPm;
    }

    protected function executeCurl($uri, $data = array(), $header = array()) {
        $header[] = 'Content-Type: application/json';
        $header[] = 'Content-Length: '.strlen(json_encode($data));
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_URL, $uri);
        curl_setopt($ch, CURLOPT_POST, count($data));
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        $result = curl_exec($ch);
        curl_close($ch);
        
        return json_decode($result, true);
    }

    protected function getToken() {
        if (empty(self::$token)) {
            $data = array(
                "CLIENT_ID"     => self::CLIENT_ID,
                "CLIENT_SECRET" => self::CLIENT_SECRET);

            $requestToken = self::executeCurl($this->getUtlServicoPm()."/requestToken", $data);

            if(!empty($requestToken)) {
                self::$token = $requestToken['dataset']['token'][0];
            }
        }
        return self::$token;
    }

    protected function getHeader() {
        if (empty(self::$header)) {
            self::$header = array(
                'OAuth-Token: '.self::getToken(),
                'OAuth-SecretId: '.self::CLIENT_SECRET);
        }
        return self::$header;
    }

    public static function getIntegracao($nome) {
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $integracao = \Facilities\Entities\Fctintegracao::findOneByNmintegracaoAndIdativoAndNrorg($nome, 'S', $nrorg);
        if (is_object($integracao))
            return $integracao->getNrseqintegracao();
        else
            return null;
    }

    public static function inserirIntegracao($nmintegracao, $descintegracao) {
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $nrseqintegracao = \Geral\Util\NovoCodigo::geraCodigo($nrorg, "FCT_INTEGRACAO", 1, 10, true);
        $dataAtual = date_create();
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $cdoperador = \Geral\Util\Ambiente::getCdOperador();

        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $fctIntegracao = new \Facilities\Entities\Fctintegracao();
        $fctIntegracao->setNrseqintegracao($nrseqintegracao);
        $fctIntegracao->setNmintegracao($nmintegracao);
        $fctIntegracao->setDescintegracao($descintegracao);
        $fctIntegracao->setIdativo('S');
        $fctIntegracao->setNrorg($nrorg);
        $fctIntegracao->setDtinclusao($dataAtual);
        $fctIntegracao->setCdoperinclusao($cdoperador);
        $fctIntegracao->setNrorginclusao($nrorg);
        $fctIntegracao->persist();
        $connection->flush();
        return $nrseqintegracao;
    }

    public static function inserirRelacionamentoIntegracao($nrseqintegracao, $nmcamposervices, $valorcamposervices, $desccampointegracao, $valorcampointegracao) {
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $nrseqrelacintegracao = \Geral\Util\NovoCodigo::geraCodigo($nrorg, "FCT_RELACIONAINTEGRACAO", 1, 10, true);
        $cdoperador = \Geral\Util\Ambiente::getCdOperador();

        $sql = "INSERT INTO FCT_RELACIONAINTEGRACAO(
        NRSEQRELACINTEGRACAO,     NRSEQINTEGRACAO,        NMCAMPOSERVICES,    VALORCAMPOSERVICES,
        DESCCAMPOINTEGRACAO,      VALORCAMPOINTEGRACAO,   IDATIVO,            NRORG,
        DTINCLUSAO,               CDOPERINCLUSAO,         NRORGINCLUSAO)
        VALUES(
        :NRSEQRELACINTEGRACAO,    :NRSEQINTEGRACAO,       :NMCAMPOSERVICES,   :VALORCAMPOSERVICES,
        :DESCCAMPOINTEGRACAO,     :VALORCAMPOINTEGRACAO,  :IDATIVO,           :NRORG,
        SYSDATE,                  :CDOPERINCLUSAO,        :NRORG)";

        $params = array(
            "NRSEQRELACINTEGRACAO"  => $nrseqrelacintegracao,
            "NRSEQINTEGRACAO"       => $nrseqintegracao,
            "NMCAMPOSERVICES"       => $nmcamposervices,
            "VALORCAMPOSERVICES"    => $valorcamposervices,
            "DESCCAMPOINTEGRACAO"   => $desccampointegracao,
            "VALORCAMPOINTEGRACAO"  => $valorcampointegracao,
            "IDATIVO"               => 'S',
            "NRORG"                 => $nrorg,
            "CDOPERINCLUSAO"        => $cdoperador
        );

        \Setforms2\Runtime\Connection::getInstance()->execute($sql, $params);
        return $nrseqrelacintegracao;
    }
}
